#version 120

uniform sampler2D texture;
uniform float width;
uniform float height;
uniform float scale;

void main()
{
	float pixelOffsetX = 1.0 / (width / scale);
	float pixelOffsetY = 1.0 / (height / scale);

    vec4 pixel = texture2D(texture, gl_TexCoord[0].xy);

    vec4 n1 = texture2D(texture, gl_TexCoord[0].xy + vec2(-pixelOffsetX, 0));
    vec4 n2 = texture2D(texture, gl_TexCoord[0].xy + vec2(pixelOffsetX, 0));
    vec4 n3 = texture2D(texture, gl_TexCoord[0].xy + vec2(0, -pixelOffsetY));
    vec4 n4 = texture2D(texture, gl_TexCoord[0].xy + vec2(0, pixelOffsetY));

    // Ghosting
    vec4 ng1 = texture2D(texture, gl_TexCoord[0].xy + vec2(-pixelOffsetX * 2, -pixelOffsetX * 2));
    vec4 ng2 = texture2D(texture, gl_TexCoord[0].xy + vec2(2, -pixelOffsetY * pixelOffsetX * 2));

    gl_FragColor.r = (pixel.r * 0.52) + (sqrt(pixel.r * n1.r) + sqrt(pixel.r * n2.r) + sqrt(pixel.r * n3.r)) / 5.54;
    gl_FragColor.g = (pixel.g * 0.52) + (sqrt(pixel.g * n1.g) + sqrt(pixel.g * n2.g)) / 3.75;
    gl_FragColor.b = (pixel.b * 0.54) + (sqrt(pixel.b * n1.b) + sqrt(pixel.b * n2.b) + sqrt(pixel.b * n4.b)) / 5.54;
    gl_FragColor.a = 1.0;

    float m = mod(int(gl_TexCoord[0].y * height), 3);
    
    if (m == 0) { gl_FragColor.r *= 0.95; }
    else if (m == 1) { gl_FragColor.g *= 0.95; }
    else if (m == 2) { gl_FragColor.b *= 0.95; }
}
